//Vlad Tudose 100 puncte
#include<cstdio>
#include<algorithm>
#define Nm 1024
#define Mm 20001
#define Km 50001
using namespace std;
int T[Nm],C[Nm],n,m,k;
struct edge
{
	int a,b,c;
} E[Mm];
bool S[Km];

bool cmp(edge a, edge b)
{
	return a.c<b.c;
}

int Find(int x)
{
	int t=x,y;

	while(T[t]>0) t=T[t];
	while(x!=t)
	{
		y=T[x];
		T[x]=t;
		x=y;
	}
	return t;
}

void Union(int x, int y)
{
	if(T[x]<T[y])
		T[y]=x;
	else
	{
		if(T[x]==T[y]) --T[y];
		T[x]=y;
	}
}

int main()
{
	int i,j=0,cost=0,a,b,ans=0;

	freopen("retea.in","r",stdin);
	freopen("retea.out","w",stdout);

	scanf("%d%d%d",&n,&m,&k);
	for(i=0;i<m;++i)
		scanf("%d%d%d",&E[i].a,&E[i].b,&E[i].c);
	sort(E,E+m,cmp);

	for(i=0;j<n-1;++i)
	{
		a=Find(E[i].a);
		b=Find(E[i].b);
		if(a==b) continue;
		C[++j]=E[i].c;
		cost+=C[j];
		Union(a,b);
	}

	S[0]=1;
	for(i=0;i<n;++i)
		for(j=k-C[i];j>=0;--j)
			if(S[j]) S[j+C[i]]=1;
	for(i=0;i<=k;++i) ans+=S[i];

	printf("%d %d\n",cost,ans);
	return 0;
}
