//Adrian Airinei 80 puncte
#include <cstdio>
#include <cstring>
#include <vector>
#include <algorithm>
#include <stdlib.h>
#include <time.h>
using namespace std;

#define MAXN 1010
#define MAXVAL 50100
#define pb push_back
#define mp make_pair

int N, M, K, tata[MAXN], rank[MAXN], V[MAXN], res, cost;
vector< pair<int, pair<int, int> > > edges;
int ok[2][MAXVAL];

int find(int x)
{
	while(tata[x]) x = tata[x];
	return x;
}

void uneste(int x, int y)
{
	if(rand()&1) tata[find(x)] = find(y);
	else tata[find(y)] = find(x);
}

void solve(void)
{
	int i, j, k, x, y, z, prev, crt, nr = 0;

	sort(edges.begin(), edges.end());

	srand(time(0));
	for(i = 0; i < edges.size(); i++)
	{
		x = edges[i].second.first;
		y = edges[i].second.second;
		if( find(x) != find(y) )
		{
			uneste(x, y);
			V[++nr] = edges[i].first;
            cost += edges[i].first;
		}
	}

	prev = 0, crt = 1, ok[prev][0] = 1;
	for(i = 1; i <= nr; i++)
	{
		memset(ok[crt], 0, sizeof(ok[crt]));
		for(j = 0; j < MAXVAL; j++)
			if((j-V[i] >= 0 && ok[prev][j-V[i]] == 1) || ok[prev][j] == 1)
				ok[crt][j] = 1;
		prev ^= 1, crt ^= 1;
	}

	for(i = K; i >= 0; i--)
		if(ok[prev][i] == 1) res++;
}

void read_data(void)
{
	int i, j, k, x, y, z;

	scanf("%d %d %d", &N, &M, &K);
	for(i = 1; i <= M; i++)
		scanf("%d %d %d", &x, &y, &z),
		edges.pb( mp(z, mp(x,y)) );
}

void write_data(void)
{
	printf("%d %d\n", cost, res);
}

int main(void)
{
	freopen("retea.in", "rt", stdin);
	freopen("retea.out", "wt", stdout);

	read_data();
	solve();
	write_data();

	return 0;
}

